/******************************************************************************
 * @file     main.c
 * @brief    Main program body
 * @version  V4.0.1
 * @date     30-July-2026
 *
 * @note
 * Copyright (C) 2022 Spintrol Electronic Technology (Shanghai) Co., Ltd.. All rights reserved.
 *
 * @attention
 * THIS SOFTWARE JUST PROVIDES CUSTOMERS WITH CODING INFORMATION REGARDING
 * THEIR PRODUCTS, WHICH AIMS AT SAVING TIME FOR THEM. SPINTROL SHALL NOT BE
 * LIABLE FOR THE USE OF THE SOFTWARE. SPINTROL DOES NOT GUARANTEE THE
 * CORRECTNESS OF THIS SOFTWARE AND RESERVES THE RIGHT TO MODIFY THE SOFTWARE
 * WITHOUT NOTIFICATION.
 *
 ******************************************************************************/

#include<stdio.h>
#include<stdlib.h>

#if defined(SPC1158)
#include "spc1158.h"
#elif defined(SPD1148)
#include "spd1148.h"
#elif defined(SPD1178)
#include "spd1178.h"
#elif defined(SPD1188)
#include "spd1188.h"
#elif defined(SPD1163)
#include "spd1163.h"
#else
#include "spc1168.h"
#endif

/* As description below, ADC result convert to voltage can calculate as the follow */
#define ValueToVoltage(x)   ((x * 3657) / 8192) /1000

#define DACTestHTH 3920
#define DACTestLTH 3472
#define DACTest165V 512

int32_t             i32VSP;
ErrorStatus         eStatus = ERROR;


/*************************************************************************************************************************
*
* @brief      In this case, DAC output 1.65V voltage, and let ADC SOC0 sample this voltage, judging the result is reasonable
*             or not at last.
*
*************************************************************************************************************************/


int main()
{
    FLASH_WALLOW();

#if defined(SPC1158)
    FLASH_SetTiming(100000000);
    /* Disable flash write access after flash operation had done */
    FLASH_WDIS();

    CLOCK_InitWithRCO(100000000UL);
#else
    FLASH_SetTiming(200000000);
    /* Disable flash write access after flash operation had done */
    FLASH_WDIS();

    CLOCK_InitWithRCO(200000000UL);
#endif

    Delay_Init();

    /*
     * Init the UART
     *
     * 1.Set the GPIO34/35 as UART FUNC
     *
     * 2.Enable the UART CLK
     *
     * 3.Set the rest para
     */
    GPIO_SetPinChannel(GPIO_34, GPIO34_UART_TXD);
    GPIO_SetPinChannel(GPIO_35, GPIO35_UART_RXD);
    CLOCK_EnableModule(UART_MODULE);
    UART_Init(UART, 38400);

    /* Enable COMP model */
    CLOCK_EnableModule(COMP_MODULE);

    /* Enable DAC buffer */
    COMP_DACBufferInit(DAC0, FALSE, FALSE);

    /* Set DAC0 output to 1.65v */
    COMP_SetDACValue10Bit(DAC0, DACTest165V);

    /* Set DAC0 as Direct mode(DAC code is immediately update) */
    COMP_SetDACCodeLoadTiming(DAC0, DAC0CTL_BIT_CODELOAD_DIRECT_MODE);

    /* Enable DAC0 */
    COMP_EnableDAC(DAC0);

    /* Enable the global INT for the ADC */
    NVIC_EnableIRQ(ADC0_IRQn);
    
    /* Init ADC */
    eStatus = ADC_Init(ADC_SOC_0, ADC_SHB_P_GND, ADC_SHB_N_DAC_BUF, SHB, ADCTRIG_Software);
    if (ERROR != eStatus)
    {
        printf("ADC_Init ERROR\n");
        return 1;
    }

    /* Set ADC as the software trigger model */
    ADC_SoftwareTrigger(ADC_SOC_0);

    /* Wait until ADC conversion finished (Interrupt flag was set) */
    while (!ADC_GetIntFlag(ADC_SOC_0));

    while (1)
    {

    }
}

void ADC0_IRQHandler(void)
{
    i32VSP = ADC_GetResult(ADC_SOC_0);
    printf("ADC SOC0 Voltage = %2fV(Raw data is %d)\n", (double)ValueToVoltage(i32VSP), i32VSP);

    /* If the result is in error range, the test PASS */
    if ((abs(i32VSP) > DACTestLTH) && (abs(i32VSP) < DACTestHTH))
    {
        printf("The DAC test PASS\n");
    }
    else
    {
        printf("The DAC test FAIL, raw data is %d\n", i32VSP);
    }

    ADC_ClearInt(ADC_SOC_0);

    Delay_Ms(500);

    /* Use software to trigger ADC SOC0 to work */
    ADC_SoftwareTrigger(ADC_SOC_0);
}
